<%
/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
%> 
<%@include file="../init.jsp" %>

<%@ page import="org.xmlportletfactory.portal.goodclient.model.userVehicles" %>
<%@ page import="org.xmlportletfactory.portal.goodclient.service.userVehiclesLocalServiceUtil" %>

<%@ page import="com.liferay.portlet.PortalPreferences" %>
<%@ page import="com.liferay.portal.kernel.util.Validator" %>
<%@ page import="com.liferay.portal.kernel.util.OrderByComparator" %>
<%@ page import="org.xmlportletfactory.portal.goodclient.UserVehiclesComparator" %>

<jsp:useBean id="addUserVehiclesURL" class="java.lang.String" scope="request" />
<jsp:useBean id="userVehiclesFilterURL" class="java.lang.String" scope="request" />
<jsp:useBean id="userVehiclesFilter" class="java.lang.String" scope="request" />
<link rel="stylesheet" type="text/css" href="/xmlpfexampleM-portlet/css/Portlet_UserVehicles.css" />
<liferay-ui:success key="userVehicles-prefs-success" message="userVehicles-prefs-success" />
<liferay-ui:success key="userVehicles-added-successfully" message="userVehicles-added-successfully" />
<liferay-ui:success key="userVehicles-deleted-successfully" message="userVehicles-deleted-successfully" />
<liferay-ui:success key="userVehicles-updated-successfully" message="userVehicles-updated-successfully" />
<c:choose>
	<c:when test='<%= (Boolean)request.getAttribute("hasAddPermission") %>'>
		<input type="button" name="addUserVehiclesButton" value="<liferay-ui:message key="userVehicles-add" />" onClick="self.location = '<%=addUserVehiclesURL %>';">
	</c:when>
</c:choose>


<%
	String iconChecked = "checked";
	String iconUnchecked = "unchecked";
	int rows_per_page = new Integer(prefs.getValue("userVehicles-rows-per-page", "5"));
	if (Validator.isNotNull(userVehiclesFilter) || !userVehiclesFilter.equalsIgnoreCase("")) {
		rows_per_page = 100;
	}
	
	SimpleDateFormat dateFormat = new SimpleDateFormat(prefs.getValue("userVehicles-date-format", "yyyy/MM/dd"));
	SimpleDateFormat dateTimeFormat = new SimpleDateFormat(prefs.getValue("userVehicles-datetime-format","yyyy/MM/dd HH:mm"));

	PortalPreferences portalPrefs = PortletPreferencesFactoryUtil.getPortalPreferences(request);

	String orderByCol = ParamUtil.getString(request, "orderByCol");
	String orderByType = ParamUtil.getString(request, "orderByType");

	if (Validator.isNotNull(orderByCol) && Validator.isNotNull(orderByType)) {
		portalPrefs.setValue("userVehicles_order", "userVehicles-order-by-col", orderByCol);
		portalPrefs.setValue("userVehicles_order", "userVehicles-order-by-type", orderByType);
	} else {
		orderByCol = portalPrefs.getValue("userVehicles_order", "userVehicles-order-by-col", "userVehicleId");
		orderByType = portalPrefs.getValue("userVehicles_order", "userVehicles-order-by-type", "asc");
	}
%>
<liferay-ui:search-container  delta='<%= rows_per_page %>' emptyResultsMessage="userVehicles-empty-results-message" orderByCol="<%= orderByCol%>" orderByType="<%= orderByType%>">
	<liferay-ui:search-container-results>

		<%
		List<userVehicles> tempResults = (List<userVehicles>)request.getAttribute("tempResults");
		results = ListUtil.subList(tempResults, searchContainer.getStart(), searchContainer.getEnd());
		total = tempResults.size();

		pageContext.setAttribute("results", results);
		pageContext.setAttribute("total", total);
		%>

	</liferay-ui:search-container-results>

	<liferay-ui:search-container-row
		className="org.xmlportletfactory.portal.goodclient.model.userVehicles"
		keyProperty="userVehicleId"
		modelVar="userVehicles"
	>

		<liferay-ui:search-container-column-text
			name="Id"
		    property="userVehicleId"
			align="right"
		/>
		<liferay-ui:search-container-column-text
			name="Description"
			property="userVehicleDescription"
			align="left"
		/>
		<liferay-ui:search-container-column-jsp
			align="right"
			path="/JSPs/userVehicles/edit_actions.jsp"
		/>

	</liferay-ui:search-container-row>

	<liferay-ui:search-iterator />

</liferay-ui:search-container>
