/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.util.PortalUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

/**
 * @author Jack A. Rider
 */
public class userVehiclesClp extends BaseModelImpl<userVehicles>
	implements userVehicles {
	public userVehiclesClp() {
	}

	public long getPrimaryKey() {
		return _userVehicleId;
	}

	public void setPrimaryKey(long pk) {
		setUserVehicleId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_userVehicleId);
	}

	public long getUserVehicleId() {
		return _userVehicleId;
	}

	public void setUserVehicleId(long userVehicleId) {
		_userVehicleId = userVehicleId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public long getUsersId() {
		return _usersId;
	}

	public void setUsersId(long usersId) {
		_usersId = usersId;
	}

	public String getUserVehicleDescription() {
		return _userVehicleDescription;
	}

	public void setUserVehicleDescription(String userVehicleDescription) {
		_userVehicleDescription = userVehicleDescription;
	}

	public userVehicles toEscapedModel() {
		if (isEscapedModel()) {
			return this;
		}
		else {
			return (userVehicles)Proxy.newProxyInstance(userVehicles.class.getClassLoader(),
				new Class[] { userVehicles.class },
				new AutoEscapeBeanHandler(this));
		}
	}

	public Object clone() {
		userVehiclesClp clone = new userVehiclesClp();

		clone.setUserVehicleId(getUserVehicleId());
		clone.setCompanyId(getCompanyId());
		clone.setGroupId(getGroupId());
		clone.setUserId(getUserId());
		clone.setUsersId(getUsersId());
		clone.setUserVehicleDescription(getUserVehicleDescription());

		return clone;
	}

	public int compareTo(userVehicles userVehicles) {
		long pk = userVehicles.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		userVehiclesClp userVehicles = null;

		try {
			userVehicles = (userVehiclesClp)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = userVehicles.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(13);

		sb.append("{userVehicleId=");
		sb.append(getUserVehicleId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", usersId=");
		sb.append(getUsersId());
		sb.append(", userVehicleDescription=");
		sb.append(getUserVehicleDescription());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(22);

		sb.append("<model><model-name>");
		sb.append("org.xmlportletfactory.portal.goodclient.model.userVehicles");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userVehicleId</column-name><column-value><![CDATA[");
		sb.append(getUserVehicleId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>usersId</column-name><column-value><![CDATA[");
		sb.append(getUsersId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userVehicleDescription</column-name><column-value><![CDATA[");
		sb.append(getUserVehicleDescription());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userVehicleId;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private long _usersId;
	private String _userVehicleDescription;
}