/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.service;

import com.liferay.portal.kernel.annotation.Isolation;
import com.liferay.portal.kernel.annotation.Propagation;
import com.liferay.portal.kernel.annotation.Transactional;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;

/**
 * The interface for the user vehicles local service.
 *
 * <p>
 * Never modify or reference this interface directly. Always use {@link userVehiclesLocalServiceUtil} to access the user vehicles local service. Add custom service methods to {@link org.xmlportletfactory.portal.goodclient.service.impl.userVehiclesLocalServiceImpl} and rerun ServiceBuilder to automatically copy the method declarations to this interface.
 * </p>
 *
 * <p>
 * This is a local service. Methods of this service will not have security checks based on the propagated JAAS credentials because this service can only be accessed from within the same VM.
 * </p>
 *
 * @author Jack A. Rider
 * @see userVehiclesLocalServiceUtil
 * @see org.xmlportletfactory.portal.goodclient.service.base.userVehiclesLocalServiceBaseImpl
 * @see org.xmlportletfactory.portal.goodclient.service.impl.userVehiclesLocalServiceImpl
 * @generated
 */
@Transactional(isolation = Isolation.PORTAL, rollbackFor =  {
	PortalException.class, SystemException.class})
public interface userVehiclesLocalService {
	/**
	* Adds the user vehicles to the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to add
	* @return the user vehicles that was added
	* @throws SystemException if a system exception occurred
	*/
	public org.xmlportletfactory.portal.goodclient.model.userVehicles adduserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Creates a new user vehicles with the primary key. Does not add the user vehicles to the database.
	*
	* @param userVehicleId the primary key for the new user vehicles
	* @return the new user vehicles
	*/
	public org.xmlportletfactory.portal.goodclient.model.userVehicles createuserVehicles(
		long userVehicleId);

	/**
	* Deletes the user vehicles with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicleId the primary key of the user vehicles to delete
	* @throws PortalException if a user vehicles with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public void deleteuserVehicles(long userVehicleId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException;

	/**
	* Deletes the user vehicles from the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to delete
	* @throws SystemException if a system exception occurred
	*/
	public void deleteuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query to search with
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query to search with
	* @param start the lower bound of the range of model instances to return
	* @param end the upper bound of the range of model instances to return (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query to search with
	* @param start the lower bound of the range of model instances to return
	* @param end the upper bound of the range of model instances to return (not inclusive)
	* @param orderByComparator the comparator to order the results by
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Counts the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query to search with
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Gets the user vehicles with the primary key.
	*
	* @param userVehicleId the primary key of the user vehicles to get
	* @return the user vehicles
	* @throws PortalException if a user vehicles with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public org.xmlportletfactory.portal.goodclient.model.userVehicles getuserVehicles(
		long userVehicleId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException;

	/**
	* Gets a range of all the user vehicleses.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of user vehicleses to return
	* @param end the upper bound of the range of user vehicleses to return (not inclusive)
	* @return the range of user vehicleses
	* @throws SystemException if a system exception occurred
	*/
	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public java.util.List<org.xmlportletfactory.portal.goodclient.model.userVehicles> getuserVehicleses(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Gets the number of user vehicleses.
	*
	* @return the number of user vehicleses
	* @throws SystemException if a system exception occurred
	*/
	@Transactional(propagation = Propagation.SUPPORTS, readOnly = true)
	public int getuserVehiclesesCount()
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Updates the user vehicles in the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to update
	* @return the user vehicles that was updated
	* @throws SystemException if a system exception occurred
	*/
	public org.xmlportletfactory.portal.goodclient.model.userVehicles updateuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException;

	/**
	* Updates the user vehicles in the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to update
	* @param merge whether to merge the user vehicles with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	* @return the user vehicles that was updated
	* @throws SystemException if a system exception occurred
	*/
	public org.xmlportletfactory.portal.goodclient.model.userVehicles updateuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles,
		boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInUser(long userId)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInUser(long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInGroup(long groupId)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInGroup(long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInUserAndGroup(long userId, long groupId)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInUserAndGroup(long userId, long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInusersIdGroup(long usersId, long groupId)
		throws com.liferay.portal.kernel.exception.SystemException;

	public java.util.List findAllInusersIdGroup(long usersId, long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException;

	public void remove(
		org.xmlportletfactory.portal.goodclient.model.userVehicles fileobj)
		throws com.liferay.portal.kernel.exception.SystemException;
}