/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.service;

import com.liferay.portal.kernel.bean.PortletBeanLocatorUtil;
import com.liferay.portal.kernel.util.ClassLoaderProxy;

/**
 * The utility for the user vehicles local service. This utility wraps {@link org.xmlportletfactory.portal.goodclient.service.impl.userVehiclesLocalServiceImpl} and is the primary access point for service operations in application layer code running on the local server.
 *
 * <p>
 * Never modify this class directly. Add custom service methods to {@link org.xmlportletfactory.portal.goodclient.service.impl.userVehiclesLocalServiceImpl} and rerun ServiceBuilder to regenerate this class.
 * </p>
 *
 * <p>
 * This is a local service. Methods of this service will not have security checks based on the propagated JAAS credentials because this service can only be accessed from within the same VM.
 * </p>
 *
 * @author Jack A. Rider
 * @see userVehiclesLocalService
 * @see org.xmlportletfactory.portal.goodclient.service.base.userVehiclesLocalServiceBaseImpl
 * @see org.xmlportletfactory.portal.goodclient.service.impl.userVehiclesLocalServiceImpl
 * @generated
 */
public class userVehiclesLocalServiceUtil {
	/**
	* Adds the user vehicles to the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to add
	* @return the user vehicles that was added
	* @throws SystemException if a system exception occurred
	*/
	public static org.xmlportletfactory.portal.goodclient.model.userVehicles adduserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().adduserVehicles(userVehicles);
	}

	/**
	* Creates a new user vehicles with the primary key. Does not add the user vehicles to the database.
	*
	* @param userVehicleId the primary key for the new user vehicles
	* @return the new user vehicles
	*/
	public static org.xmlportletfactory.portal.goodclient.model.userVehicles createuserVehicles(
		long userVehicleId) {
		return getService().createuserVehicles(userVehicleId);
	}

	/**
	* Deletes the user vehicles with the primary key from the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicleId the primary key of the user vehicles to delete
	* @throws PortalException if a user vehicles with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static void deleteuserVehicles(long userVehicleId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		getService().deleteuserVehicles(userVehicleId);
	}

	/**
	* Deletes the user vehicles from the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to delete
	* @throws SystemException if a system exception occurred
	*/
	public static void deleteuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException {
		getService().deleteuserVehicles(userVehicles);
	}

	/**
	* Performs a dynamic query on the database and returns the matching rows.
	*
	* @param dynamicQuery the dynamic query to search with
	* @return the matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery);
	}

	/**
	* Performs a dynamic query on the database and returns a range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query to search with
	* @param start the lower bound of the range of model instances to return
	* @param end the upper bound of the range of model instances to return (not inclusive)
	* @return the range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end) throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQuery(dynamicQuery, start, end);
	}

	/**
	* Performs a dynamic query on the database and returns an ordered range of the matching rows.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param dynamicQuery the dynamic query to search with
	* @param start the lower bound of the range of model instances to return
	* @param end the upper bound of the range of model instances to return (not inclusive)
	* @param orderByComparator the comparator to order the results by
	* @return the ordered range of matching rows
	* @throws SystemException if a system exception occurred
	*/
	@SuppressWarnings("rawtypes")
	public static java.util.List dynamicQuery(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery, int start,
		int end,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .dynamicQuery(dynamicQuery, start, end, orderByComparator);
	}

	/**
	* Counts the number of rows that match the dynamic query.
	*
	* @param dynamicQuery the dynamic query to search with
	* @return the number of rows that match the dynamic query
	* @throws SystemException if a system exception occurred
	*/
	public static long dynamicQueryCount(
		com.liferay.portal.kernel.dao.orm.DynamicQuery dynamicQuery)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().dynamicQueryCount(dynamicQuery);
	}

	/**
	* Gets the user vehicles with the primary key.
	*
	* @param userVehicleId the primary key of the user vehicles to get
	* @return the user vehicles
	* @throws PortalException if a user vehicles with the primary key could not be found
	* @throws SystemException if a system exception occurred
	*/
	public static org.xmlportletfactory.portal.goodclient.model.userVehicles getuserVehicles(
		long userVehicleId)
		throws com.liferay.portal.kernel.exception.PortalException,
			com.liferay.portal.kernel.exception.SystemException {
		return getService().getuserVehicles(userVehicleId);
	}

	/**
	* Gets a range of all the user vehicleses.
	*
	* <p>
	* Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	* </p>
	*
	* @param start the lower bound of the range of user vehicleses to return
	* @param end the upper bound of the range of user vehicleses to return (not inclusive)
	* @return the range of user vehicleses
	* @throws SystemException if a system exception occurred
	*/
	public static java.util.List<org.xmlportletfactory.portal.goodclient.model.userVehicles> getuserVehicleses(
		int start, int end)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getuserVehicleses(start, end);
	}

	/**
	* Gets the number of user vehicleses.
	*
	* @return the number of user vehicleses
	* @throws SystemException if a system exception occurred
	*/
	public static int getuserVehiclesesCount()
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().getuserVehiclesesCount();
	}

	/**
	* Updates the user vehicles in the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to update
	* @return the user vehicles that was updated
	* @throws SystemException if a system exception occurred
	*/
	public static org.xmlportletfactory.portal.goodclient.model.userVehicles updateuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().updateuserVehicles(userVehicles);
	}

	/**
	* Updates the user vehicles in the database. Also notifies the appropriate model listeners.
	*
	* @param userVehicles the user vehicles to update
	* @param merge whether to merge the user vehicles with the current session. See {@link com.liferay.portal.service.persistence.BatchSession#update(com.liferay.portal.kernel.dao.orm.Session, com.liferay.portal.model.BaseModel, boolean)} for an explanation.
	* @return the user vehicles that was updated
	* @throws SystemException if a system exception occurred
	*/
	public static org.xmlportletfactory.portal.goodclient.model.userVehicles updateuserVehicles(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles,
		boolean merge)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().updateuserVehicles(userVehicles, merge);
	}

	public static java.util.List findAllInUser(long userId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInUser(userId);
	}

	public static java.util.List findAllInUser(long userId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInUser(userId, orderByComparator);
	}

	public static java.util.List findAllInGroup(long groupId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInGroup(groupId);
	}

	public static java.util.List findAllInGroup(long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInGroup(groupId, orderByComparator);
	}

	public static java.util.List findAllInUserAndGroup(long userId, long groupId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInUserAndGroup(userId, groupId);
	}

	public static java.util.List findAllInUserAndGroup(long userId,
		long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .findAllInUserAndGroup(userId, groupId, orderByComparator);
	}

	public static java.util.List findAllInusersIdGroup(long usersId,
		long groupId)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService().findAllInusersIdGroup(usersId, groupId);
	}

	public static java.util.List findAllInusersIdGroup(long usersId,
		long groupId,
		com.liferay.portal.kernel.util.OrderByComparator orderByComparator)
		throws com.liferay.portal.kernel.exception.SystemException {
		return getService()
				   .findAllInusersIdGroup(usersId, groupId, orderByComparator);
	}

	public static void remove(
		org.xmlportletfactory.portal.goodclient.model.userVehicles fileobj)
		throws com.liferay.portal.kernel.exception.SystemException {
		getService().remove(fileobj);
	}

	public static void clearService() {
		_service = null;
	}

	public static userVehiclesLocalService getService() {
		if (_service == null) {
			Object obj = PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					userVehiclesLocalService.class.getName());
			ClassLoader portletClassLoader = (ClassLoader)PortletBeanLocatorUtil.locate(ClpSerializer.SERVLET_CONTEXT_NAME,
					"portletClassLoader");

			ClassLoaderProxy classLoaderProxy = new ClassLoaderProxy(obj,
					portletClassLoader);

			_service = new userVehiclesLocalServiceClp(classLoaderProxy);

			ClpSerializer.setClassLoader(portletClassLoader);
		}

		return _service;
	}

	public void setService(userVehiclesLocalService service) {
		_service = service;
	}

	private static userVehiclesLocalService _service;
}