/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
 
 package org.xmlportletfactory.portal.goodclient;

import java.io.File;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.text.ParseException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.Enumeration;
import java.util.List;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.Event;
import javax.portlet.EventRequest;
import javax.portlet.EventResponse;
import javax.portlet.PortletException;
import javax.portlet.PortletPreferences;
import javax.portlet.PortletRequestDispatcher;
import javax.portlet.PortletURL;
import javax.portlet.ProcessAction;
import javax.portlet.ProcessEvent;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;
import javax.xml.namespace.QName;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.portlet.PortletFileUpload;

import org.xmlportletfactory.portal.goodclient.model.userVehicles;
import org.xmlportletfactory.portal.goodclient.model.impl.userVehiclesImpl;
import org.xmlportletfactory.portal.goodclient.service.userVehiclesLocalServiceUtil;


import com.liferay.portal.kernel.cache.MultiVMPoolUtil;
import com.liferay.portal.kernel.dao.orm.Criterion;
import com.liferay.portal.kernel.dao.orm.DynamicQuery;
import com.liferay.portal.kernel.dao.orm.DynamicQueryFactoryUtil;
import com.liferay.portal.kernel.dao.orm.PropertyFactoryUtil;
import com.liferay.portal.kernel.dao.orm.RestrictionsFactoryUtil;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.servlet.SessionErrors;
import com.liferay.portal.kernel.servlet.SessionMessages;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.ParamUtil;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.kernel.util.WebKeys;
import com.liferay.portal.model.User;
import com.liferay.portal.security.permission.PermissionChecker;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.service.ServiceContextFactory;
import com.liferay.portal.service.UserLocalServiceUtil;
import com.liferay.portal.theme.ThemeDisplay;
import com.liferay.portlet.documentlibrary.model.DLFileEntry;
import com.liferay.portlet.documentlibrary.model.DLFolder;
import com.liferay.portlet.documentlibrary.service.DLFileEntryLocalServiceUtil;
import com.liferay.portlet.documentlibrary.service.DLFolderLocalServiceUtil;
import com.liferay.portlet.imagegallery.model.IGFolder;
import com.liferay.portlet.imagegallery.model.IGImage;
import com.liferay.portlet.imagegallery.service.IGFolderLocalServiceUtil;
import com.liferay.portlet.imagegallery.service.IGImageLocalServiceUtil;
import com.liferay.util.bridges.mvc.MVCPortlet;

/**
 * Portlet implementation class UserVehicles
 */
public class UserVehiclesPortlet extends MVCPortlet {



	public void init() throws PortletException {

		// Edit Mode Pages
		editJSP = getInitParameter("edit-jsp");

		// Help Mode Pages
		helpJSP = getInitParameter("help-jsp");

		// View Mode Pages
		viewJSP = getInitParameter("view-jsp");

		// View Mode Edit userVehicles
		edituserVehiclesJSP = getInitParameter("edit-userVehicles-jsp");
	}

	protected void include(String path, RenderRequest renderRequest,
			RenderResponse renderResponse) throws IOException, PortletException {

		PortletRequestDispatcher portletRequestDispatcher = getPortletContext()
				.getRequestDispatcher(path);

		if (portletRequestDispatcher == null) {
			// do nothing
			// _log.error(path + " is not a valid include");
		} else {
			portletRequestDispatcher.include(renderRequest, renderResponse);
		}
	}

	public void doView(RenderRequest renderRequest,
			RenderResponse renderResponse) throws IOException, PortletException {

		String jsp = (String) renderRequest.getParameter("view");
		if (jsp == null || jsp.equals("")) {
			showViewDefault(renderRequest, renderResponse);
		} else if (jsp.equalsIgnoreCase("editUserVehicles")) {
			try {
				showViewEditUserVehicles(renderRequest, renderResponse);
			} catch (Exception ex) {
				_log.debug(ex);
				try {
					showViewDefault(renderRequest, renderResponse);
				} catch (Exception ex1) {
					_log.debug(ex1);
				}
			}
		}
	}

	public void doEdit(RenderRequest renderRequest,
			RenderResponse renderResponse) throws IOException, PortletException {

		showEditDefault(renderRequest, renderResponse);
	}

	public void doHelp(RenderRequest renderRequest,
			RenderResponse renderResponse) throws IOException, PortletException {

		include(helpJSP, renderRequest, renderResponse);
	}

	@SuppressWarnings("unchecked")
	public void showViewDefault(RenderRequest renderRequest,
			RenderResponse renderResponse) throws IOException, PortletException {

		ThemeDisplay themeDisplay = (ThemeDisplay) renderRequest
				.getAttribute(WebKeys.THEME_DISPLAY);

		long groupId = themeDisplay.getScopeGroupId();

		PermissionChecker permissionChecker = themeDisplay
				.getPermissionChecker();

		boolean hasAddPermission = permissionChecker.hasPermission(groupId,
				"org.xmlportletfactory.portal.goodclient.model", groupId, "ADD_USERVEHICLES");

		List<userVehicles> tempResults = Collections.EMPTY_LIST;
		long usersId = 0;
		String usersIdStr = renderRequest.getPortletSession().getAttribute("usersId")+ "";
		if (!usersIdStr.trim().equalsIgnoreCase("")){
			try {
				usersId = Long.parseLong(usersIdStr);
			} catch (Exception e) {
				usersId = 0;
			}
		}
		try {
			String orderByType = renderRequest.getParameter("orderByType");
			String orderByCol  = renderRequest.getParameter("orderByCol");
			OrderByComparator comparator = UserVehiclesComparator.getUserVehiclesOrderByComparator(orderByCol,orderByType);
			tempResults = userVehiclesLocalServiceUtil.findAllInusersIdGroup(usersId, groupId,comparator);
		} catch (Exception e) {
			_log.debug(e);
		}
        if (usersId == 0) {
            hasAddPermission = false;
        } else {
            renderRequest.getPortletSession().setAttribute("USERVEHICLESusersId", usersId);
        }
		renderRequest.setAttribute("tempResults", tempResults);
		renderRequest.setAttribute("hasAddPermission", hasAddPermission);

		PortletURL addUserVehiclesURL = renderResponse.createActionURL();
		addUserVehiclesURL.setParameter("javax.portlet.action", "newUserVehicles");
		renderRequest.setAttribute("addUserVehiclesURL", addUserVehiclesURL.toString());

		PortletURL userVehiclesFilterURL = renderResponse.createRenderURL();
		userVehiclesFilterURL.setParameter("javax.portlet.action", "doView");
		renderRequest.setAttribute("userVehiclesFilterURL", userVehiclesFilterURL.toString());

		include(viewJSP, renderRequest, renderResponse);
	}

	public void showViewEditUserVehicles(RenderRequest renderRequest, RenderResponse renderResponse) throws Exception {

		SimpleDateFormat formatDia    = new SimpleDateFormat("dd");
		SimpleDateFormat formatMes    = new SimpleDateFormat("MM");
		SimpleDateFormat formatAno    = new SimpleDateFormat("yyyy");
		SimpleDateFormat formatHora   = new SimpleDateFormat("HH");
		SimpleDateFormat formatMinuto = new SimpleDateFormat("mm");

		PortletURL editUserVehiclesURL = renderResponse.createActionURL();
		String editType = (String) renderRequest.getParameter("editType");
		if (editType.equalsIgnoreCase("edit")) {
			editUserVehiclesURL.setParameter("javax.portlet.action", "updateUserVehicles");
			long userVehicleId = Long.parseLong(renderRequest.getParameter("userVehicleId"));
			userVehicles userVehicles = userVehiclesLocalServiceUtil.getuserVehicles(userVehicleId);
			String usersId = userVehicles.getUsersId()+"";
			renderRequest.setAttribute("usersId", usersId);
			String userVehicleDescription = userVehicles.getUserVehicleDescription()+"";
			renderRequest.setAttribute("userVehicleDescription", userVehicleDescription);
            renderRequest.setAttribute("userVehicles", userVehicles);
		} else {
			editUserVehiclesURL.setParameter("javax.portlet.action", "addUserVehicles");
			userVehicles errorUserVehicles = (userVehicles) renderRequest.getAttribute("errorUserVehicles");
			if (errorUserVehicles != null) {
				if (editType.equalsIgnoreCase("update")) {
					editUserVehiclesURL.setParameter("javax.portlet.action", "updateUserVehicles");
                }
				renderRequest.setAttribute("userVehicles", errorUserVehicles);
			} else {
				userVehiclesImpl blankUserVehicles = new userVehiclesImpl();
				blankUserVehicles.setUserVehicleId(0);
				blankUserVehicles.setUsersId((Long) renderRequest.getPortletSession().getAttribute("USERVEHICLESusersId"));
				blankUserVehicles.setUserVehicleDescription("");
                String usersIdStr = (String) renderRequest.getPortletSession().getAttribute("claseId");
				renderRequest.setAttribute("usersId", usersIdStr);
				renderRequest.setAttribute("userVehicles", blankUserVehicles);
			}

		}

		ThemeDisplay themeDisplay = (ThemeDisplay) renderRequest.getAttribute(WebKeys.THEME_DISPLAY);


		renderRequest.setAttribute("editUserVehiclesURL", editUserVehiclesURL.toString());

		include(edituserVehiclesJSP, renderRequest, renderResponse);
	}

	private String dateToJsp(ActionRequest request, Date date) {
		PortletPreferences prefs = request.getPreferences();
		return dateToJsp(prefs, date);
	}
	private String dateToJsp(RenderRequest request, Date date) {
		PortletPreferences prefs = request.getPreferences();
		return dateToJsp(prefs, date);
	}
	private String dateToJsp(PortletPreferences prefs, Date date) {
		SimpleDateFormat format = new SimpleDateFormat(prefs.getValue("userVehicles-date-format", "yyyy/MM/dd"));
		String stringDate = format.format(date);
		return stringDate;
	}
	private String dateTimeToJsp(Date date) {
		SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm");
		String stringDate = format.format(date);
		return stringDate;
	}

	public void showEditDefault(RenderRequest renderRequest,
			RenderResponse renderResponse) throws PortletException, IOException {

		include(editJSP, renderRequest, renderResponse);
	}

	/* Portlet Actions */

	@ProcessAction(name = "newUserVehicles")
	public void newUserVehicles(ActionRequest request, ActionResponse response) {
		response.setRenderParameter("view", "editUserVehicles");
		response.setRenderParameter("editType", "add");
	}

	@ProcessAction(name = "addUserVehicles")
	public void addUserVehicles(ActionRequest request, ActionResponse response) throws Exception {
            ArrayList<String> errors = new ArrayList();
            userVehicles userVehicles = userVehiclesFromRequest(request);
            if (UserVehiclesValidator.validateUserVehicles(userVehicles, errors)) {
				userVehiclesLocalServiceUtil.adduserVehicles(userVehicles);
                MultiVMPoolUtil.clear();
                response.setRenderParameter("view", "");
                SessionMessages.add(request, "userVehicles-added-successfully");
            } else {
                for (String error : errors) {
                        SessionErrors.add(request, error);
                }
                response.setRenderParameter("view", "editUserVehicles");
                response.setRenderParameter("editType", "add");
                request.setAttribute("errorUserVehicles", userVehicles);
            }
	}

	@ProcessAction(name = "eventUserVehicles")
	public void eventUserVehicles(ActionRequest request, ActionResponse response)
			throws Exception {
		long key = ParamUtil.getLong(request, "resourcePrimKey");
		if (Validator.isNotNull(key)) {
		}
	}

	@ProcessAction(name = "editUserVehicles")
	public void editUserVehicles(ActionRequest request, ActionResponse response)
			throws Exception {
		long key = ParamUtil.getLong(request, "resourcePrimKey");
		if (Validator.isNotNull(key)) {
			response.setRenderParameter("userVehicleId", Long.toString(key));
			response.setRenderParameter("view", "editUserVehicles");
			response.setRenderParameter("editType", "edit");
		}
	}

	@ProcessAction(name = "deleteUserVehicles")
	public void deleteUserVehicles(ActionRequest request, ActionResponse response)throws Exception {
		long id = ParamUtil.getLong(request, "resourcePrimKey");
		if (Validator.isNotNull(id)) {
			userVehicles userVehicles = userVehiclesLocalServiceUtil.getuserVehicles(id);
			userVehiclesLocalServiceUtil.deleteuserVehicles(userVehicles);
            MultiVMPoolUtil.clear();
			SessionMessages.add(request, "userVehicles-deleted-successfully");
		} else {
			SessionErrors.add(request, "userVehicles-error-deleting");
		}
	}

	@ProcessAction(name = "updateUserVehicles")
	public void updateUserVehicles(ActionRequest request, ActionResponse response) throws Exception {
            ArrayList<String> errors = new ArrayList();
            userVehicles userVehicles = userVehiclesFromRequest(request);
            if (UserVehiclesValidator.validateUserVehicles(userVehicles, errors)) {
                userVehiclesLocalServiceUtil.updateuserVehicles(userVehicles);
                MultiVMPoolUtil.clear();
                response.setRenderParameter("view", "");
                SessionMessages.add(request, "userVehicles-updated-successfully");
            } else {
                for (String error : errors) {
                        SessionErrors.add(request, error);
                }
				response.setRenderParameter("userVehicleId)",Long.toString(userVehicles.getPrimaryKey()));
				response.setRenderParameter("view", "editUserVehicles");
				response.setRenderParameter("editType", "update");
				request.setAttribute("errorUserVehicles", userVehicles);
            }
        }

	@ProcessAction(name = "setUserVehiclesPref")
	public void setUserVehiclesPref(ActionRequest request, ActionResponse response) throws Exception {

		String rowsPerPage = ParamUtil.getString(request, "userVehicles-rows-per-page");
		String dateFormat = ParamUtil.getString(request, "userVehicles-date-format");
		String datetimeFormat = ParamUtil.getString(request, "userVehicles-datetime-format");

		ArrayList<String> errors = new ArrayList();
		if (UserVehiclesValidator.validateEditUserVehicles(rowsPerPage, dateFormat, datetimeFormat, errors)) {
			response.setRenderParameter("userVehicles-rows-per-page", "");
			response.setRenderParameter("userVehicles-date-format", "");
			response.setRenderParameter("userVehicles-datetime-format", "");

			PortletPreferences prefs = request.getPreferences();
			prefs.setValue("userVehicles-rows-per-page", rowsPerPage);
			prefs.setValue("userVehicles-date-format", dateFormat);
			prefs.setValue("userVehicles-datetime-format", datetimeFormat);
			prefs.store();

			SessionMessages.add(request, "userVehicles-prefs-success");
		}
	}

	private userVehicles userVehiclesFromRequest(ActionRequest request) {
		ThemeDisplay themeDisplay = (ThemeDisplay) request.getAttribute(WebKeys.THEME_DISPLAY);
		userVehiclesImpl userVehicles = new userVehiclesImpl();
        try {
            userVehicles.setUserVehicleId(ParamUtil.getLong(request, "userVehicleId"));
        } catch (Exception nfe) {
		    //Controled en Validator
        }
        try {
            userVehicles.setUsersId(ParamUtil.getLong(request, "usersId"));
        } catch (Exception nfe) {
		    //Controled en Validator
        }
		userVehicles.setUserVehicleDescription(ParamUtil.getString(request, "userVehicleDescription"));
		try {
		    userVehicles.setPrimaryKey(ParamUtil.getLong(request,"resourcePrimKey"));
		} catch (NumberFormatException nfe) {
			//Controled en Validator
        }
		userVehicles.setCompanyId(themeDisplay.getCompanyId());
		userVehicles.setGroupId(themeDisplay.getScopeGroupId());
		userVehicles.setUserId(themeDisplay.getUserId());
		return userVehicles;
	}

	@ProcessEvent(qname="{http://liferay.com/events}Users.usersId")
	public void reciveEvent(EventRequest request, EventResponse response) {
		Event event = request.getEvent();
		String usersId = (String)event.getValue();
		request.getPortletSession().setAttribute("usersId",usersId);
		response.setRenderParameter("usersId", usersId);
	}
	protected String edituserVehiclesJSP;
	protected String editJSP;
	protected String helpJSP;
	protected String viewJSP;

	private static Log _log = LogFactoryUtil.getLog(UserVehiclesPortlet.class);

}
