/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
 
 package org.xmlportletfactory.portal.goodclient;

import java.io.IOException;
import java.io.InputStream;
import java.text.SimpleDateFormat;
import java.util.List;
import java.util.Properties;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.xmlportletfactory.portal.goodclient.model.userVehicles;

import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.Validator;

public class UserVehiclesValidator {

	public static boolean validateUserVehicles(userVehicles userVehicles, List<String> errors) throws IOException {
		boolean validate = true;
		Properties props = new Properties();
		ClassLoader classLoader = UserVehiclesValidator.class.getClassLoader();
		InputStream is = classLoader.getResourceAsStream("regexp.properties");
		props.load(is);

	//Field usersId
		if(!validateUsersId(props,Long.toString(userVehicles.getUsersId()))){
		    errors.add("error");
			validate = false;
		}
	//Field userVehicleDescription
		if(!validateUserVehicleDescription(props,userVehicles.getUserVehicleDescription())){
		    errors.add("error");
			validate = false;
		}
		return validate;
	}

	public static boolean validateEditUserVehicles(
		String rowsPerPage, String dateFormat, String datetimeFormat, List errors) {
		boolean valid = true;
		if (Validator.isNull(rowsPerPage)) {
			errors.add("userVehicles-rows-per-page-required");
			valid = false;
		} else if (!Validator.isNumber(rowsPerPage)) {
			errors.add("userVehicles-rows-per-page-invalid");
			valid = false;
		} else if (Validator.isNull(dateFormat)) {
			errors.add("userVehicles-date-format-required");
			valid = false;
		} else if (Validator.isNull(datetimeFormat)) {
			errors.add("userVehicles-datetime_format.required");
			valid = false;
		}
		return valid;
	}

	//Field userVehicleId
	private static boolean validateUserVehicleId(Properties props,String field) {
		boolean validate = true;
		return validate;
	}
	//Field usersId
	private static boolean validateUsersId(Properties props,String field) {
		boolean validate = true;
		return validate;
	}
	//Field userVehicleDescription
	private static boolean validateUserVehicleDescription(Properties props,String field) {
		boolean validate = true;
		return validate;
	}


}
