/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import org.xmlportletfactory.portal.goodclient.model.userVehicles;
import org.xmlportletfactory.portal.goodclient.model.userVehiclesModel;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.sql.Types;

/**
 * The base model implementation for the userVehicles service. Represents a row in the &quot;xmlpfexamplem_userVehicles&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link org.xmlportletfactory.portal.goodclient.model.userVehiclesModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link userVehiclesImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this class directly. All methods that expect a user vehicles model instance should use the {@link org.xmlportletfactory.portal.goodclient.model.userVehicles} interface instead.
 * </p>
 *
 * @author Jack A. Rider
 * @see userVehiclesImpl
 * @see org.xmlportletfactory.portal.goodclient.model.userVehicles
 * @see org.xmlportletfactory.portal.goodclient.model.userVehiclesModel
 * @generated
 */
public class userVehiclesModelImpl extends BaseModelImpl<userVehicles>
	implements userVehiclesModel {
	public static final String TABLE_NAME = "xmlpfexamplem_userVehicles";
	public static final Object[][] TABLE_COLUMNS = {
			{ "userVehicleId", new Integer(Types.BIGINT) },
			{ "companyId", new Integer(Types.BIGINT) },
			{ "groupId", new Integer(Types.BIGINT) },
			{ "userId", new Integer(Types.BIGINT) },
			{ "usersId", new Integer(Types.BIGINT) },
			{ "userVehicleDescription", new Integer(Types.VARCHAR) }
		};
	public static final String TABLE_SQL_CREATE = "create table xmlpfexamplem_userVehicles (userVehicleId LONG not null primary key,companyId LONG,groupId LONG,userId LONG,usersId LONG,userVehicleDescription VARCHAR(30) null)";
	public static final String TABLE_SQL_DROP = "drop table xmlpfexamplem_userVehicles";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.org.xmlportletfactory.portal.goodclient.model.userVehicles"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.org.xmlportletfactory.portal.goodclient.model.userVehicles"),
			true);
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.org.xmlportletfactory.portal.goodclient.model.userVehicles"));

	public userVehiclesModelImpl() {
	}

	public long getPrimaryKey() {
		return _userVehicleId;
	}

	public void setPrimaryKey(long pk) {
		setUserVehicleId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_userVehicleId);
	}

	public long getUserVehicleId() {
		return _userVehicleId;
	}

	public void setUserVehicleId(long userVehicleId) {
		_userVehicleId = userVehicleId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public long getUserId() {
		return _userId;
	}

	public void setUserId(long userId) {
		_userId = userId;
	}

	public String getUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
	}

	public void setUserUuid(String userUuid) {
		_userUuid = userUuid;
	}

	public long getUsersId() {
		return _usersId;
	}

	public void setUsersId(long usersId) {
		_usersId = usersId;
	}

	public String getUserVehicleDescription() {
		if (_userVehicleDescription == null) {
			return StringPool.BLANK;
		}
		else {
			return _userVehicleDescription;
		}
	}

	public void setUserVehicleDescription(String userVehicleDescription) {
		_userVehicleDescription = userVehicleDescription;
	}

	public userVehicles toEscapedModel() {
		if (isEscapedModel()) {
			return (userVehicles)this;
		}
		else {
			return (userVehicles)Proxy.newProxyInstance(userVehicles.class.getClassLoader(),
				new Class[] { userVehicles.class },
				new AutoEscapeBeanHandler(this));
		}
	}

	public ExpandoBridge getExpandoBridge() {
		if (_expandoBridge == null) {
			_expandoBridge = ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
					userVehicles.class.getName(), getPrimaryKey());
		}

		return _expandoBridge;
	}

	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		getExpandoBridge().setAttributes(serviceContext);
	}

	public Object clone() {
		userVehiclesImpl userVehiclesImpl = new userVehiclesImpl();

		userVehiclesImpl.setUserVehicleId(getUserVehicleId());

		userVehiclesImpl.setCompanyId(getCompanyId());

		userVehiclesImpl.setGroupId(getGroupId());

		userVehiclesImpl.setUserId(getUserId());

		userVehiclesImpl.setUsersId(getUsersId());

		userVehiclesImpl.setUserVehicleDescription(getUserVehicleDescription());

		return userVehiclesImpl;
	}

	public int compareTo(userVehicles userVehicles) {
		long pk = userVehicles.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		userVehicles userVehicles = null;

		try {
			userVehicles = (userVehicles)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = userVehicles.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(13);

		sb.append("{userVehicleId=");
		sb.append(getUserVehicleId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append(", userId=");
		sb.append(getUserId());
		sb.append(", usersId=");
		sb.append(getUsersId());
		sb.append(", userVehicleDescription=");
		sb.append(getUserVehicleDescription());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(22);

		sb.append("<model><model-name>");
		sb.append("org.xmlportletfactory.portal.goodclient.model.userVehicles");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>userVehicleId</column-name><column-value><![CDATA[");
		sb.append(getUserVehicleId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userId</column-name><column-value><![CDATA[");
		sb.append(getUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>usersId</column-name><column-value><![CDATA[");
		sb.append(getUsersId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>userVehicleDescription</column-name><column-value><![CDATA[");
		sb.append(getUserVehicleDescription());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _userVehicleId;
	private long _companyId;
	private long _groupId;
	private long _userId;
	private String _userUuid;
	private long _usersId;
	private String _userVehicleDescription;
	private transient ExpandoBridge _expandoBridge;
}