/**
 *     Copyright (C) 2009-2011  Jack A. Rider All rights reserved.
 * 
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 * 
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 */
 
 package org.xmlportletfactory.portal.goodclient.service.impl;

import java.util.List;

import org.xmlportletfactory.portal.goodclient.model.userVehicles;
import org.xmlportletfactory.portal.goodclient.service.base.userVehiclesLocalServiceBaseImpl;
import org.xmlportletfactory.portal.goodclient.service.persistence.userVehiclesUtil;
import com.liferay.counter.service.CounterLocalServiceUtil;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.dao.orm.QueryUtil;

import com.liferay.portlet.documentlibrary.service.DLFolderLocalServiceUtil;
import com.liferay.portlet.imagegallery.service.IGFolderLocalServiceUtil;
import com.liferay.portal.kernel.exception.PortalException;

/**
 * @author Jack A. Rider
 */
public class userVehiclesLocalServiceImpl extends userVehiclesLocalServiceBaseImpl {

	@SuppressWarnings("unchecked")
	public List findAllInUser(long userId)throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUserId(userId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUser(long userId, OrderByComparator orderByComparator) throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUserId(userId, QueryUtil.ALL_POS,QueryUtil.ALL_POS, orderByComparator);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInGroup(long groupId) throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByGroupId(groupId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInGroup(long groupId, OrderByComparator orderByComparator) throws SystemException{
		List <userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByGroupId(groupId,QueryUtil.ALL_POS,QueryUtil.ALL_POS, orderByComparator);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUserAndGroup(long userId, long groupId) throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUserIdGroupId(userId, groupId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInUserAndGroup(long userId, long groupId, OrderByComparator orderByComparator) throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUserIdGroupId(userId, groupId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, orderByComparator);
		return list;
	}



	@SuppressWarnings("unchecked")
	public List findAllInusersIdGroup(long usersId, long groupId)	throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUsersIdGroupId(usersId, groupId);
		return list;
	}

	@SuppressWarnings("unchecked")
	public List findAllInusersIdGroup(long usersId, long groupId, OrderByComparator orderByComparator) throws SystemException {
		List<userVehicles> list = (List<userVehicles>) userVehiclesUtil.findByUsersIdGroupId(usersId, groupId, QueryUtil.ALL_POS,QueryUtil.ALL_POS, orderByComparator);
		return list;
	}


	public userVehicles adduserVehicles (userVehicles validuserVehicles) throws SystemException {
	    userVehicles fileobj = userVehiclesUtil.create(CounterLocalServiceUtil.increment(userVehicles.class.getName()));

	    fileobj.setCompanyId(validuserVehicles.getCompanyId());
	    fileobj.setGroupId(validuserVehicles.getGroupId());
	    fileobj.setUserId(validuserVehicles.getUserId());

	    fileobj.setUsersId(validuserVehicles.getUsersId());
	    fileobj.setUserVehicleDescription(validuserVehicles.getUserVehicleDescription());

	    return userVehiclesUtil.update(fileobj, false);
	}

	public void remove(userVehicles fileobj) throws SystemException {
	    userVehiclesUtil.remove(fileobj);
	}
}