/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package org.xmlportletfactory.portal.goodclient.service.persistence;

import com.liferay.portal.NoSuchModelException;
import com.liferay.portal.kernel.annotation.BeanReference;
import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.SQLQuery;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.security.permission.InlineSQLHelperUtil;
import com.liferay.portal.service.persistence.BatchSessionUtil;
import com.liferay.portal.service.persistence.ResourcePersistence;
import com.liferay.portal.service.persistence.UserPersistence;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException;
import org.xmlportletfactory.portal.goodclient.model.impl.userVehiclesImpl;
import org.xmlportletfactory.portal.goodclient.model.impl.userVehiclesModelImpl;
import org.xmlportletfactory.portal.goodclient.model.userVehicles;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * The persistence implementation for the user vehicles service.
 *
 * <p>
 * Never modify or reference this class directly. Always use {@link userVehiclesUtil} to access the user vehicles persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
 * </p>
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Jack A. Rider
 * @see userVehiclesPersistence
 * @see userVehiclesUtil
 * @generated
 */
public class userVehiclesPersistenceImpl extends BasePersistenceImpl<userVehicles>
	implements userVehiclesPersistence {
	public static final String FINDER_CLASS_NAME_ENTITY = userVehiclesImpl.class.getName();
	public static final String FINDER_CLASS_NAME_LIST = FINDER_CLASS_NAME_ENTITY +
		".List";
	public static final FinderPath FINDER_PATH_FIND_BY_GROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findByGroupId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_COUNT_BY_GROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countByGroupId", new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_FIND_BY_USERID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findByUserId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_COUNT_BY_USERID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countByUserId", new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_FIND_BY_USERIDGROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findByUserIdGroupId",
			new String[] {
				Long.class.getName(), Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_COUNT_BY_USERIDGROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countByUserIdGroupId",
			new String[] { Long.class.getName(), Long.class.getName() });
	public static final FinderPath FINDER_PATH_FIND_BY_USERSID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findByUsersId",
			new String[] {
				Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_COUNT_BY_USERSID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countByUsersId", new String[] { Long.class.getName() });
	public static final FinderPath FINDER_PATH_FIND_BY_USERSIDGROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findByUsersIdGroupId",
			new String[] {
				Long.class.getName(), Long.class.getName(),
				
			"java.lang.Integer", "java.lang.Integer",
				"com.liferay.portal.kernel.util.OrderByComparator"
			});
	public static final FinderPath FINDER_PATH_COUNT_BY_USERSIDGROUPID = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countByUsersIdGroupId",
			new String[] { Long.class.getName(), Long.class.getName() });
	public static final FinderPath FINDER_PATH_FIND_ALL = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"findAll", new String[0]);
	public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesModelImpl.FINDER_CACHE_ENABLED, FINDER_CLASS_NAME_LIST,
			"countAll", new String[0]);

	/**
	 * Caches the user vehicles in the entity cache if it is enabled.
	 *
	 * @param userVehicles the user vehicles to cache
	 */
	public void cacheResult(userVehicles userVehicles) {
		EntityCacheUtil.putResult(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesImpl.class, userVehicles.getPrimaryKey(), userVehicles);
	}

	/**
	 * Caches the user vehicleses in the entity cache if it is enabled.
	 *
	 * @param userVehicleses the user vehicleses to cache
	 */
	public void cacheResult(List<userVehicles> userVehicleses) {
		for (userVehicles userVehicles : userVehicleses) {
			if (EntityCacheUtil.getResult(
						userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
						userVehiclesImpl.class, userVehicles.getPrimaryKey(),
						this) == null) {
				cacheResult(userVehicles);
			}
		}
	}

	/**
	 * Clears the cache for all user vehicleses.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	public void clearCache() {
		CacheRegistryUtil.clear(userVehiclesImpl.class.getName());
		EntityCacheUtil.clearCache(userVehiclesImpl.class.getName());
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST);
	}

	/**
	 * Clears the cache for the user vehicles.
	 *
	 * <p>
	 * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
	 * </p>
	 */
	public void clearCache(userVehicles userVehicles) {
		EntityCacheUtil.removeResult(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesImpl.class, userVehicles.getPrimaryKey());
	}

	/**
	 * Creates a new user vehicles with the primary key. Does not add the user vehicles to the database.
	 *
	 * @param userVehicleId the primary key for the new user vehicles
	 * @return the new user vehicles
	 */
	public userVehicles create(long userVehicleId) {
		userVehicles userVehicles = new userVehiclesImpl();

		userVehicles.setNew(true);
		userVehicles.setPrimaryKey(userVehicleId);

		return userVehicles;
	}

	/**
	 * Removes the user vehicles with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param primaryKey the primary key of the user vehicles to remove
	 * @return the user vehicles that was removed
	 * @throws com.liferay.portal.NoSuchModelException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles remove(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return remove(((Long)primaryKey).longValue());
	}

	/**
	 * Removes the user vehicles with the primary key from the database. Also notifies the appropriate model listeners.
	 *
	 * @param userVehicleId the primary key of the user vehicles to remove
	 * @return the user vehicles that was removed
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles remove(long userVehicleId)
		throws NoSuchuserVehiclesException, SystemException {
		Session session = null;

		try {
			session = openSession();

			userVehicles userVehicles = (userVehicles)session.get(userVehiclesImpl.class,
					new Long(userVehicleId));

			if (userVehicles == null) {
				if (_log.isWarnEnabled()) {
					_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + userVehicleId);
				}

				throw new NoSuchuserVehiclesException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
					userVehicleId);
			}

			return remove(userVehicles);
		}
		catch (NoSuchuserVehiclesException nsee) {
			throw nsee;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles removeImpl(userVehicles userVehicles)
		throws SystemException {
		userVehicles = toUnwrappedModel(userVehicles);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.delete(session, userVehicles);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST);

		EntityCacheUtil.removeResult(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesImpl.class, userVehicles.getPrimaryKey());

		return userVehicles;
	}

	public userVehicles updateImpl(
		org.xmlportletfactory.portal.goodclient.model.userVehicles userVehicles,
		boolean merge) throws SystemException {
		userVehicles = toUnwrappedModel(userVehicles);

		Session session = null;

		try {
			session = openSession();

			BatchSessionUtil.update(session, userVehicles, merge);

			userVehicles.setNew(false);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}

		FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST);

		EntityCacheUtil.putResult(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
			userVehiclesImpl.class, userVehicles.getPrimaryKey(), userVehicles);

		return userVehicles;
	}

	protected userVehicles toUnwrappedModel(userVehicles userVehicles) {
		if (userVehicles instanceof userVehiclesImpl) {
			return userVehicles;
		}

		userVehiclesImpl userVehiclesImpl = new userVehiclesImpl();

		userVehiclesImpl.setNew(userVehicles.isNew());
		userVehiclesImpl.setPrimaryKey(userVehicles.getPrimaryKey());

		userVehiclesImpl.setUserVehicleId(userVehicles.getUserVehicleId());
		userVehiclesImpl.setCompanyId(userVehicles.getCompanyId());
		userVehiclesImpl.setGroupId(userVehicles.getGroupId());
		userVehiclesImpl.setUserId(userVehicles.getUserId());
		userVehiclesImpl.setUsersId(userVehicles.getUsersId());
		userVehiclesImpl.setUserVehicleDescription(userVehicles.getUserVehicleDescription());

		return userVehiclesImpl;
	}

	/**
	 * Finds the user vehicles with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
	 *
	 * @param primaryKey the primary key of the user vehicles to find
	 * @return the user vehicles
	 * @throws com.liferay.portal.NoSuchModelException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByPrimaryKey(Serializable primaryKey)
		throws NoSuchModelException, SystemException {
		return findByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Finds the user vehicles with the primary key or throws a {@link org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException} if it could not be found.
	 *
	 * @param userVehicleId the primary key of the user vehicles to find
	 * @return the user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByPrimaryKey(long userVehicleId)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = fetchByPrimaryKey(userVehicleId);

		if (userVehicles == null) {
			if (_log.isWarnEnabled()) {
				_log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + userVehicleId);
			}

			throw new NoSuchuserVehiclesException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
				userVehicleId);
		}

		return userVehicles;
	}

	/**
	 * Finds the user vehicles with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param primaryKey the primary key of the user vehicles to find
	 * @return the user vehicles, or <code>null</code> if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles fetchByPrimaryKey(Serializable primaryKey)
		throws SystemException {
		return fetchByPrimaryKey(((Long)primaryKey).longValue());
	}

	/**
	 * Finds the user vehicles with the primary key or returns <code>null</code> if it could not be found.
	 *
	 * @param userVehicleId the primary key of the user vehicles to find
	 * @return the user vehicles, or <code>null</code> if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles fetchByPrimaryKey(long userVehicleId)
		throws SystemException {
		userVehicles userVehicles = (userVehicles)EntityCacheUtil.getResult(userVehiclesModelImpl.ENTITY_CACHE_ENABLED,
				userVehiclesImpl.class, userVehicleId, this);

		if (userVehicles == null) {
			Session session = null;

			try {
				session = openSession();

				userVehicles = (userVehicles)session.get(userVehiclesImpl.class,
						new Long(userVehicleId));
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (userVehicles != null) {
					cacheResult(userVehicles);
				}

				closeSession(session);
			}
		}

		return userVehicles;
	}

	/**
	 * Finds all the user vehicleses where groupId = &#63;.
	 *
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByGroupId(long groupId)
		throws SystemException {
		return findByGroupId(groupId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByGroupId(long groupId, int start, int end)
		throws SystemException {
		return findByGroupId(groupId, start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByGroupId(long groupId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		Object[] finderArgs = new Object[] {
				groupId,
				
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_BY_GROUPID,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(2);
			}

			query.append(_SQL_SELECT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(groupId);

				list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_BY_GROUPID,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_BY_GROUPID,
						finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Finds the first user vehicles in the ordered set where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the first matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByGroupId_First(long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		List<userVehicles> list = findByGroupId(groupId, 0, 1, orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the last user vehicles in the ordered set where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the last matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByGroupId_Last(long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		int count = countByGroupId(groupId);

		List<userVehicles> list = findByGroupId(groupId, count - 1, count,
				orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the user vehicleses before and after the current user vehicles in the ordered set where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userVehicleId the primary key of the current user vehicles
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the previous, current, and next user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles[] findByGroupId_PrevAndNext(long userVehicleId,
		long groupId, OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = findByPrimaryKey(userVehicleId);

		Session session = null;

		try {
			session = openSession();

			userVehicles[] array = new userVehiclesImpl[3];

			array[0] = getByGroupId_PrevAndNext(session, userVehicles, groupId,
					orderByComparator, true);

			array[1] = userVehicles;

			array[2] = getByGroupId_PrevAndNext(session, userVehicles, groupId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles getByGroupId_PrevAndNext(Session session,
		userVehicles userVehicles, long groupId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

		if (orderByComparator != null) {
			String[] orderByFields = orderByComparator.getOrderByFields();

			if (orderByFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(groupId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByValues(userVehicles);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<userVehicles> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Filters by the user's permissions and finds all the user vehicleses where groupId = &#63;.
	 *
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByGroupId(long groupId)
		throws SystemException {
		return filterFindByGroupId(groupId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Filters by the user's permissions and finds a range of all the user vehicleses where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByGroupId(long groupId, int start,
		int end) throws SystemException {
		return filterFindByGroupId(groupId, start, end, null);
	}

	/**
	 * Filters by the user's permissions and finds an ordered range of all the user vehicleses where groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByGroupId(long groupId, int start,
		int end, OrderByComparator orderByComparator) throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return findByGroupId(groupId, start, end, orderByComparator);
		}

		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(3 +
					(orderByComparator.getOrderByFields().length * 3));
		}
		else {
			query = new StringBundler(2);
		}

		if (getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_WHERE);
		}
		else {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_1);
		}

		query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

		if (!getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_2);
		}

		if (orderByComparator != null) {
			if (getDB().isSupportsInlineDistinct()) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_TABLE,
					orderByComparator);
			}
		}

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			if (getDB().isSupportsInlineDistinct()) {
				q.addEntity(_FILTER_ENTITY_ALIAS, userVehiclesImpl.class);
			}
			else {
				q.addEntity(_FILTER_ENTITY_TABLE, userVehiclesImpl.class);
			}

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(groupId);

			return (List<userVehicles>)QueryUtil.list(q, getDialect(), start,
				end);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Finds all the user vehicleses where userId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @return the matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserId(long userId)
		throws SystemException {
		return findByUserId(userId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserId(long userId, int start, int end)
		throws SystemException {
		return findByUserId(userId, start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserId(long userId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		Object[] finderArgs = new Object[] {
				userId,
				
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_BY_USERID,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(2);
			}

			query.append(_SQL_SELECT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_BY_USERID,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_BY_USERID,
						finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Finds the first user vehicles in the ordered set where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the first matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUserId_First(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		List<userVehicles> list = findByUserId(userId, 0, 1, orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("userId=");
			msg.append(userId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the last user vehicles in the ordered set where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the last matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUserId_Last(long userId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		int count = countByUserId(userId);

		List<userVehicles> list = findByUserId(userId, count - 1, count,
				orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("userId=");
			msg.append(userId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the user vehicleses before and after the current user vehicles in the ordered set where userId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userVehicleId the primary key of the current user vehicles
	 * @param userId the user id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the previous, current, and next user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles[] findByUserId_PrevAndNext(long userVehicleId,
		long userId, OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = findByPrimaryKey(userVehicleId);

		Session session = null;

		try {
			session = openSession();

			userVehicles[] array = new userVehiclesImpl[3];

			array[0] = getByUserId_PrevAndNext(session, userVehicles, userId,
					orderByComparator, true);

			array[1] = userVehicles;

			array[2] = getByUserId_PrevAndNext(session, userVehicles, userId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles getByUserId_PrevAndNext(Session session,
		userVehicles userVehicles, long userId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERID_USERID_2);

		if (orderByComparator != null) {
			String[] orderByFields = orderByComparator.getOrderByFields();

			if (orderByFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(userId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByValues(userVehicles);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<userVehicles> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Finds all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserIdGroupId(long userId, long groupId)
		throws SystemException {
		return findByUserIdGroupId(userId, groupId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserIdGroupId(long userId, long groupId,
		int start, int end) throws SystemException {
		return findByUserIdGroupId(userId, groupId, start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUserIdGroupId(long userId, long groupId,
		int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		Object[] finderArgs = new Object[] {
				userId, groupId,
				
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_BY_USERIDGROUPID,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(4 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERIDGROUPID_USERID_2);

			query.append(_FINDER_COLUMN_USERIDGROUPID_GROUPID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				qPos.add(groupId);

				list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_BY_USERIDGROUPID,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_BY_USERIDGROUPID,
						finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Finds the first user vehicles in the ordered set where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the first matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUserIdGroupId_First(long userId, long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		List<userVehicles> list = findByUserIdGroupId(userId, groupId, 0, 1,
				orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(6);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("userId=");
			msg.append(userId);

			msg.append(", groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the last user vehicles in the ordered set where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the last matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUserIdGroupId_Last(long userId, long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		int count = countByUserIdGroupId(userId, groupId);

		List<userVehicles> list = findByUserIdGroupId(userId, groupId,
				count - 1, count, orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(6);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("userId=");
			msg.append(userId);

			msg.append(", groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the user vehicleses before and after the current user vehicles in the ordered set where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userVehicleId the primary key of the current user vehicles
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the previous, current, and next user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles[] findByUserIdGroupId_PrevAndNext(long userVehicleId,
		long userId, long groupId, OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = findByPrimaryKey(userVehicleId);

		Session session = null;

		try {
			session = openSession();

			userVehicles[] array = new userVehiclesImpl[3];

			array[0] = getByUserIdGroupId_PrevAndNext(session, userVehicles,
					userId, groupId, orderByComparator, true);

			array[1] = userVehicles;

			array[2] = getByUserIdGroupId_PrevAndNext(session, userVehicles,
					userId, groupId, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles getByUserIdGroupId_PrevAndNext(Session session,
		userVehicles userVehicles, long userId, long groupId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERIDGROUPID_USERID_2);

		query.append(_FINDER_COLUMN_USERIDGROUPID_GROUPID_2);

		if (orderByComparator != null) {
			String[] orderByFields = orderByComparator.getOrderByFields();

			if (orderByFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(userId);

		qPos.add(groupId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByValues(userVehicles);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<userVehicles> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Filters by the user's permissions and finds all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUserIdGroupId(long userId,
		long groupId) throws SystemException {
		return filterFindByUserIdGroupId(userId, groupId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Filters by the user's permissions and finds a range of all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUserIdGroupId(long userId,
		long groupId, int start, int end) throws SystemException {
		return filterFindByUserIdGroupId(userId, groupId, start, end, null);
	}

	/**
	 * Filters by the user's permissions and finds an ordered range of all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUserIdGroupId(long userId,
		long groupId, int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return findByUserIdGroupId(userId, groupId, start, end,
				orderByComparator);
		}

		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(4 +
					(orderByComparator.getOrderByFields().length * 3));
		}
		else {
			query = new StringBundler(3);
		}

		if (getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_WHERE);
		}
		else {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_1);
		}

		query.append(_FINDER_COLUMN_USERIDGROUPID_USERID_2);

		query.append(_FINDER_COLUMN_USERIDGROUPID_GROUPID_2);

		if (!getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_2);
		}

		if (orderByComparator != null) {
			if (getDB().isSupportsInlineDistinct()) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_TABLE,
					orderByComparator);
			}
		}

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			if (getDB().isSupportsInlineDistinct()) {
				q.addEntity(_FILTER_ENTITY_ALIAS, userVehiclesImpl.class);
			}
			else {
				q.addEntity(_FILTER_ENTITY_TABLE, userVehiclesImpl.class);
			}

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(userId);

			qPos.add(groupId);

			return (List<userVehicles>)QueryUtil.list(q, getDialect(), start,
				end);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Finds all the user vehicleses where usersId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @return the matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersId(long usersId)
		throws SystemException {
		return findByUsersId(usersId, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses where usersId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersId(long usersId, int start, int end)
		throws SystemException {
		return findByUsersId(usersId, start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses where usersId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersId(long usersId, int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		Object[] finderArgs = new Object[] {
				usersId,
				
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_BY_USERSID,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(3 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(2);
			}

			query.append(_SQL_SELECT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERSID_USERSID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(usersId);

				list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_BY_USERSID,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_BY_USERSID,
						finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Finds the first user vehicles in the ordered set where usersId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the first matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUsersId_First(long usersId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		List<userVehicles> list = findByUsersId(usersId, 0, 1, orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("usersId=");
			msg.append(usersId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the last user vehicles in the ordered set where usersId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the last matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUsersId_Last(long usersId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		int count = countByUsersId(usersId);

		List<userVehicles> list = findByUsersId(usersId, count - 1, count,
				orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(4);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("usersId=");
			msg.append(usersId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the user vehicleses before and after the current user vehicles in the ordered set where usersId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userVehicleId the primary key of the current user vehicles
	 * @param usersId the users id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the previous, current, and next user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles[] findByUsersId_PrevAndNext(long userVehicleId,
		long usersId, OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = findByPrimaryKey(userVehicleId);

		Session session = null;

		try {
			session = openSession();

			userVehicles[] array = new userVehiclesImpl[3];

			array[0] = getByUsersId_PrevAndNext(session, userVehicles, usersId,
					orderByComparator, true);

			array[1] = userVehicles;

			array[2] = getByUsersId_PrevAndNext(session, userVehicles, usersId,
					orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles getByUsersId_PrevAndNext(Session session,
		userVehicles userVehicles, long usersId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERSID_USERSID_2);

		if (orderByComparator != null) {
			String[] orderByFields = orderByComparator.getOrderByFields();

			if (orderByFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(usersId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByValues(userVehicles);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<userVehicles> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Finds all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersIdGroupId(long usersId, long groupId)
		throws SystemException {
		return findByUsersIdGroupId(usersId, groupId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersIdGroupId(long usersId, long groupId,
		int start, int end) throws SystemException {
		return findByUsersIdGroupId(usersId, groupId, start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findByUsersIdGroupId(long usersId, long groupId,
		int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		Object[] finderArgs = new Object[] {
				usersId, groupId,
				
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_BY_USERSIDGROUPID,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;

			if (orderByComparator != null) {
				query = new StringBundler(4 +
						(orderByComparator.getOrderByFields().length * 3));
			}
			else {
				query = new StringBundler(3);
			}

			query.append(_SQL_SELECT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERSIDGROUPID_USERSID_2);

			query.append(_FINDER_COLUMN_USERSIDGROUPID_GROUPID_2);

			if (orderByComparator != null) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(usersId);

				qPos.add(groupId);

				list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
						start, end);
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_BY_USERSIDGROUPID,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_BY_USERSIDGROUPID,
						finderArgs, list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Finds the first user vehicles in the ordered set where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the first matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUsersIdGroupId_First(long usersId, long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		List<userVehicles> list = findByUsersIdGroupId(usersId, groupId, 0, 1,
				orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(6);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("usersId=");
			msg.append(usersId);

			msg.append(", groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the last user vehicles in the ordered set where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the last matching user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a matching user vehicles could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles findByUsersIdGroupId_Last(long usersId, long groupId,
		OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		int count = countByUsersIdGroupId(usersId, groupId);

		List<userVehicles> list = findByUsersIdGroupId(usersId, groupId,
				count - 1, count, orderByComparator);

		if (list.isEmpty()) {
			StringBundler msg = new StringBundler(6);

			msg.append(_NO_SUCH_ENTITY_WITH_KEY);

			msg.append("usersId=");
			msg.append(usersId);

			msg.append(", groupId=");
			msg.append(groupId);

			msg.append(StringPool.CLOSE_CURLY_BRACE);

			throw new NoSuchuserVehiclesException(msg.toString());
		}
		else {
			return list.get(0);
		}
	}

	/**
	 * Finds the user vehicleses before and after the current user vehicles in the ordered set where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param userVehicleId the primary key of the current user vehicles
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param orderByComparator the comparator to order the set by
	 * @return the previous, current, and next user vehicles
	 * @throws org.xmlportletfactory.portal.goodclient.NoSuchuserVehiclesException if a user vehicles with the primary key could not be found
	 * @throws SystemException if a system exception occurred
	 */
	public userVehicles[] findByUsersIdGroupId_PrevAndNext(long userVehicleId,
		long usersId, long groupId, OrderByComparator orderByComparator)
		throws NoSuchuserVehiclesException, SystemException {
		userVehicles userVehicles = findByPrimaryKey(userVehicleId);

		Session session = null;

		try {
			session = openSession();

			userVehicles[] array = new userVehiclesImpl[3];

			array[0] = getByUsersIdGroupId_PrevAndNext(session, userVehicles,
					usersId, groupId, orderByComparator, true);

			array[1] = userVehicles;

			array[2] = getByUsersIdGroupId_PrevAndNext(session, userVehicles,
					usersId, groupId, orderByComparator, false);

			return array;
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	protected userVehicles getByUsersIdGroupId_PrevAndNext(Session session,
		userVehicles userVehicles, long usersId, long groupId,
		OrderByComparator orderByComparator, boolean previous) {
		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(6 +
					(orderByComparator.getOrderByFields().length * 6));
		}
		else {
			query = new StringBundler(3);
		}

		query.append(_SQL_SELECT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERSIDGROUPID_USERSID_2);

		query.append(_FINDER_COLUMN_USERSIDGROUPID_GROUPID_2);

		if (orderByComparator != null) {
			String[] orderByFields = orderByComparator.getOrderByFields();

			if (orderByFields.length > 0) {
				query.append(WHERE_AND);
			}

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN_HAS_NEXT);
					}
					else {
						query.append(WHERE_LESSER_THAN_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(WHERE_GREATER_THAN);
					}
					else {
						query.append(WHERE_LESSER_THAN);
					}
				}
			}

			query.append(ORDER_BY_CLAUSE);

			for (int i = 0; i < orderByFields.length; i++) {
				query.append(_ORDER_BY_ENTITY_ALIAS);
				query.append(orderByFields[i]);

				if ((i + 1) < orderByFields.length) {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC_HAS_NEXT);
					}
					else {
						query.append(ORDER_BY_DESC_HAS_NEXT);
					}
				}
				else {
					if (orderByComparator.isAscending() ^ previous) {
						query.append(ORDER_BY_ASC);
					}
					else {
						query.append(ORDER_BY_DESC);
					}
				}
			}
		}

		String sql = query.toString();

		Query q = session.createQuery(sql);

		q.setFirstResult(0);
		q.setMaxResults(2);

		QueryPos qPos = QueryPos.getInstance(q);

		qPos.add(usersId);

		qPos.add(groupId);

		if (orderByComparator != null) {
			Object[] values = orderByComparator.getOrderByValues(userVehicles);

			for (Object value : values) {
				qPos.add(value);
			}
		}

		List<userVehicles> list = q.list();

		if (list.size() == 2) {
			return list.get(1);
		}
		else {
			return null;
		}
	}

	/**
	 * Filters by the user's permissions and finds all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @return the matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUsersIdGroupId(long usersId,
		long groupId) throws SystemException {
		return filterFindByUsersIdGroupId(usersId, groupId, QueryUtil.ALL_POS,
			QueryUtil.ALL_POS, null);
	}

	/**
	 * Filters by the user's permissions and finds a range of all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUsersIdGroupId(long usersId,
		long groupId, int start, int end) throws SystemException {
		return filterFindByUsersIdGroupId(usersId, groupId, start, end, null);
	}

	/**
	 * Filters by the user's permissions and finds an ordered range of all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> filterFindByUsersIdGroupId(long usersId,
		long groupId, int start, int end, OrderByComparator orderByComparator)
		throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return findByUsersIdGroupId(usersId, groupId, start, end,
				orderByComparator);
		}

		StringBundler query = null;

		if (orderByComparator != null) {
			query = new StringBundler(4 +
					(orderByComparator.getOrderByFields().length * 3));
		}
		else {
			query = new StringBundler(3);
		}

		if (getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_WHERE);
		}
		else {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_1);
		}

		query.append(_FINDER_COLUMN_USERSIDGROUPID_USERSID_2);

		query.append(_FINDER_COLUMN_USERSIDGROUPID_GROUPID_2);

		if (!getDB().isSupportsInlineDistinct()) {
			query.append(_FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_2);
		}

		if (orderByComparator != null) {
			if (getDB().isSupportsInlineDistinct()) {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);
			}
			else {
				appendOrderByComparator(query, _ORDER_BY_ENTITY_TABLE,
					orderByComparator);
			}
		}

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			if (getDB().isSupportsInlineDistinct()) {
				q.addEntity(_FILTER_ENTITY_ALIAS, userVehiclesImpl.class);
			}
			else {
				q.addEntity(_FILTER_ENTITY_TABLE, userVehiclesImpl.class);
			}

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(usersId);

			qPos.add(groupId);

			return (List<userVehicles>)QueryUtil.list(q, getDialect(), start,
				end);
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Finds all the user vehicleses.
	 *
	 * @return the user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findAll() throws SystemException {
		return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
	}

	/**
	 * Finds a range of all the user vehicleses.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @return the range of user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findAll(int start, int end)
		throws SystemException {
		return findAll(start, end, null);
	}

	/**
	 * Finds an ordered range of all the user vehicleses.
	 *
	 * <p>
	 * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set.
	 * </p>
	 *
	 * @param start the lower bound of the range of user vehicleses to return
	 * @param end the upper bound of the range of user vehicleses to return (not inclusive)
	 * @param orderByComparator the comparator to order the results by
	 * @return the ordered range of user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public List<userVehicles> findAll(int start, int end,
		OrderByComparator orderByComparator) throws SystemException {
		Object[] finderArgs = new Object[] {
				String.valueOf(start), String.valueOf(end),
				String.valueOf(orderByComparator)
			};

		List<userVehicles> list = (List<userVehicles>)FinderCacheUtil.getResult(FINDER_PATH_FIND_ALL,
				finderArgs, this);

		if (list == null) {
			StringBundler query = null;
			String sql = null;

			if (orderByComparator != null) {
				query = new StringBundler(2 +
						(orderByComparator.getOrderByFields().length * 3));

				query.append(_SQL_SELECT_USERVEHICLES);

				appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
					orderByComparator);

				sql = query.toString();
			}
			else {
				sql = _SQL_SELECT_USERVEHICLES;
			}

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				if (orderByComparator == null) {
					list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
							start, end, false);

					Collections.sort(list);
				}
				else {
					list = (List<userVehicles>)QueryUtil.list(q, getDialect(),
							start, end);
				}
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (list == null) {
					FinderCacheUtil.removeResult(FINDER_PATH_FIND_ALL,
						finderArgs);
				}
				else {
					cacheResult(list);

					FinderCacheUtil.putResult(FINDER_PATH_FIND_ALL, finderArgs,
						list);
				}

				closeSession(session);
			}
		}

		return list;
	}

	/**
	 * Removes all the user vehicleses where groupId = &#63; from the database.
	 *
	 * @param groupId the group id to search with
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByGroupId(long groupId) throws SystemException {
		for (userVehicles userVehicles : findByGroupId(groupId)) {
			remove(userVehicles);
		}
	}

	/**
	 * Removes all the user vehicleses where userId = &#63; from the database.
	 *
	 * @param userId the user id to search with
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUserId(long userId) throws SystemException {
		for (userVehicles userVehicles : findByUserId(userId)) {
			remove(userVehicles);
		}
	}

	/**
	 * Removes all the user vehicleses where userId = &#63; and groupId = &#63; from the database.
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUserIdGroupId(long userId, long groupId)
		throws SystemException {
		for (userVehicles userVehicles : findByUserIdGroupId(userId, groupId)) {
			remove(userVehicles);
		}
	}

	/**
	 * Removes all the user vehicleses where usersId = &#63; from the database.
	 *
	 * @param usersId the users id to search with
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUsersId(long usersId) throws SystemException {
		for (userVehicles userVehicles : findByUsersId(usersId)) {
			remove(userVehicles);
		}
	}

	/**
	 * Removes all the user vehicleses where usersId = &#63; and groupId = &#63; from the database.
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @throws SystemException if a system exception occurred
	 */
	public void removeByUsersIdGroupId(long usersId, long groupId)
		throws SystemException {
		for (userVehicles userVehicles : findByUsersIdGroupId(usersId, groupId)) {
			remove(userVehicles);
		}
	}

	/**
	 * Removes all the user vehicleses from the database.
	 *
	 * @throws SystemException if a system exception occurred
	 */
	public void removeAll() throws SystemException {
		for (userVehicles userVehicles : findAll()) {
			remove(userVehicles);
		}
	}

	/**
	 * Counts all the user vehicleses where groupId = &#63;.
	 *
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countByGroupId(long groupId) throws SystemException {
		Object[] finderArgs = new Object[] { groupId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_GROUPID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(groupId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_GROUPID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Filters by the user's permissions and counts all the user vehicleses where groupId = &#63;.
	 *
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public int filterCountByGroupId(long groupId) throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return countByGroupId(groupId);
		}

		StringBundler query = new StringBundler(2);

		query.append(_FILTER_SQL_COUNT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_GROUPID_GROUPID_2);

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			q.addScalar(COUNT_COLUMN_NAME,
				com.liferay.portal.kernel.dao.orm.Type.LONG);

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(groupId);

			Long count = (Long)q.uniqueResult();

			return count.intValue();
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Counts all the user vehicleses where userId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @return the number of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUserId(long userId) throws SystemException {
		Object[] finderArgs = new Object[] { userId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERID_USERID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Counts all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUserIdGroupId(long userId, long groupId)
		throws SystemException {
		Object[] finderArgs = new Object[] { userId, groupId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERIDGROUPID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(3);

			query.append(_SQL_COUNT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERIDGROUPID_USERID_2);

			query.append(_FINDER_COLUMN_USERIDGROUPID_GROUPID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(userId);

				qPos.add(groupId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERIDGROUPID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Filters by the user's permissions and counts all the user vehicleses where userId = &#63; and groupId = &#63;.
	 *
	 * @param userId the user id to search with
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public int filterCountByUserIdGroupId(long userId, long groupId)
		throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return countByUserIdGroupId(userId, groupId);
		}

		StringBundler query = new StringBundler(3);

		query.append(_FILTER_SQL_COUNT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERIDGROUPID_USERID_2);

		query.append(_FINDER_COLUMN_USERIDGROUPID_GROUPID_2);

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			q.addScalar(COUNT_COLUMN_NAME,
				com.liferay.portal.kernel.dao.orm.Type.LONG);

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(userId);

			qPos.add(groupId);

			Long count = (Long)q.uniqueResult();

			return count.intValue();
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Counts all the user vehicleses where usersId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @return the number of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUsersId(long usersId) throws SystemException {
		Object[] finderArgs = new Object[] { usersId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERSID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(2);

			query.append(_SQL_COUNT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERSID_USERSID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(usersId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERSID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Counts all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countByUsersIdGroupId(long usersId, long groupId)
		throws SystemException {
		Object[] finderArgs = new Object[] { usersId, groupId };

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_BY_USERSIDGROUPID,
				finderArgs, this);

		if (count == null) {
			StringBundler query = new StringBundler(3);

			query.append(_SQL_COUNT_USERVEHICLES_WHERE);

			query.append(_FINDER_COLUMN_USERSIDGROUPID_USERSID_2);

			query.append(_FINDER_COLUMN_USERSIDGROUPID_GROUPID_2);

			String sql = query.toString();

			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(sql);

				QueryPos qPos = QueryPos.getInstance(q);

				qPos.add(usersId);

				qPos.add(groupId);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_USERSIDGROUPID,
					finderArgs, count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Filters by the user's permissions and counts all the user vehicleses where usersId = &#63; and groupId = &#63;.
	 *
	 * @param usersId the users id to search with
	 * @param groupId the group id to search with
	 * @return the number of matching user vehicleses that the user has permission to view
	 * @throws SystemException if a system exception occurred
	 */
	public int filterCountByUsersIdGroupId(long usersId, long groupId)
		throws SystemException {
		if (!InlineSQLHelperUtil.isEnabled(groupId)) {
			return countByUsersIdGroupId(usersId, groupId);
		}

		StringBundler query = new StringBundler(3);

		query.append(_FILTER_SQL_COUNT_USERVEHICLES_WHERE);

		query.append(_FINDER_COLUMN_USERSIDGROUPID_USERSID_2);

		query.append(_FINDER_COLUMN_USERSIDGROUPID_GROUPID_2);

		String sql = InlineSQLHelperUtil.replacePermissionCheck(query.toString(),
				userVehicles.class.getName(), _FILTER_COLUMN_PK,
				_FILTER_COLUMN_USERID, groupId);

		Session session = null;

		try {
			session = openSession();

			SQLQuery q = session.createSQLQuery(sql);

			q.addScalar(COUNT_COLUMN_NAME,
				com.liferay.portal.kernel.dao.orm.Type.LONG);

			QueryPos qPos = QueryPos.getInstance(q);

			qPos.add(usersId);

			qPos.add(groupId);

			Long count = (Long)q.uniqueResult();

			return count.intValue();
		}
		catch (Exception e) {
			throw processException(e);
		}
		finally {
			closeSession(session);
		}
	}

	/**
	 * Counts all the user vehicleses.
	 *
	 * @return the number of user vehicleses
	 * @throws SystemException if a system exception occurred
	 */
	public int countAll() throws SystemException {
		Object[] finderArgs = new Object[0];

		Long count = (Long)FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
				finderArgs, this);

		if (count == null) {
			Session session = null;

			try {
				session = openSession();

				Query q = session.createQuery(_SQL_COUNT_USERVEHICLES);

				count = (Long)q.uniqueResult();
			}
			catch (Exception e) {
				throw processException(e);
			}
			finally {
				if (count == null) {
					count = Long.valueOf(0);
				}

				FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL, finderArgs,
					count);

				closeSession(session);
			}
		}

		return count.intValue();
	}

	/**
	 * Initializes the user vehicles persistence.
	 */
	public void afterPropertiesSet() {
		String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
					com.liferay.util.service.ServiceProps.get(
						"value.object.listener.org.xmlportletfactory.portal.goodclient.model.userVehicles")));

		if (listenerClassNames.length > 0) {
			try {
				List<ModelListener<userVehicles>> listenersList = new ArrayList<ModelListener<userVehicles>>();

				for (String listenerClassName : listenerClassNames) {
					listenersList.add((ModelListener<userVehicles>)InstanceFactory.newInstance(
							listenerClassName));
				}

				listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
			}
			catch (Exception e) {
				_log.error(e);
			}
		}
	}

	public void destroy() {
		EntityCacheUtil.removeCache(userVehiclesImpl.class.getName());
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
		FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST);
	}

	@BeanReference(type = usersPersistence.class)
	protected usersPersistence usersPersistence;
	@BeanReference(type = userVehiclesPersistence.class)
	protected userVehiclesPersistence userVehiclesPersistence;
	@BeanReference(type = ResourcePersistence.class)
	protected ResourcePersistence resourcePersistence;
	@BeanReference(type = UserPersistence.class)
	protected UserPersistence userPersistence;
	private static final String _SQL_SELECT_USERVEHICLES = "SELECT userVehicles FROM userVehicles userVehicles";
	private static final String _SQL_SELECT_USERVEHICLES_WHERE = "SELECT userVehicles FROM userVehicles userVehicles WHERE ";
	private static final String _SQL_COUNT_USERVEHICLES = "SELECT COUNT(userVehicles) FROM userVehicles userVehicles";
	private static final String _SQL_COUNT_USERVEHICLES_WHERE = "SELECT COUNT(userVehicles) FROM userVehicles userVehicles WHERE ";
	private static final String _FINDER_COLUMN_GROUPID_GROUPID_2 = "userVehicles.groupId = ?";
	private static final String _FINDER_COLUMN_USERID_USERID_2 = "userVehicles.userId = ?";
	private static final String _FINDER_COLUMN_USERIDGROUPID_USERID_2 = "userVehicles.userId = ? AND ";
	private static final String _FINDER_COLUMN_USERIDGROUPID_GROUPID_2 = "userVehicles.groupId = ?";
	private static final String _FINDER_COLUMN_USERSID_USERSID_2 = "userVehicles.usersId = ?";
	private static final String _FINDER_COLUMN_USERSIDGROUPID_USERSID_2 = "userVehicles.usersId = ? AND ";
	private static final String _FINDER_COLUMN_USERSIDGROUPID_GROUPID_2 = "userVehicles.groupId = ?";
	private static final String _FILTER_SQL_SELECT_USERVEHICLES_WHERE = "SELECT DISTINCT {userVehicles.*} FROM xmlpfexamplem_userVehicles userVehicles WHERE ";
	private static final String _FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_1 =
		"SELECT {xmlpfexamplem_userVehicles.*} FROM (SELECT DISTINCT userVehicles.userVehicleId FROM xmlpfexamplem_userVehicles userVehicles WHERE ";
	private static final String _FILTER_SQL_SELECT_USERVEHICLES_NO_INLINE_DISTINCT_WHERE_2 =
		") TEMP_TABLE INNER JOIN xmlpfexamplem_userVehicles ON TEMP_TABLE.userVehicleId = xmlpfexamplem_userVehicles.userVehicleId";
	private static final String _FILTER_SQL_COUNT_USERVEHICLES_WHERE = "SELECT COUNT(DISTINCT userVehicles.userVehicleId) AS COUNT_VALUE FROM xmlpfexamplem_userVehicles userVehicles WHERE ";
	private static final String _FILTER_COLUMN_PK = "userVehicles.userVehicleId";
	private static final String _FILTER_COLUMN_USERID = "userVehicles.userId";
	private static final String _FILTER_ENTITY_ALIAS = "userVehicles";
	private static final String _FILTER_ENTITY_TABLE = "xmlpfexamplem_userVehicles";
	private static final String _ORDER_BY_ENTITY_ALIAS = "userVehicles.";
	private static final String _ORDER_BY_ENTITY_TABLE = "xmlpfexamplem_userVehicles.";
	private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No userVehicles exists with the primary key ";
	private static final String _NO_SUCH_ENTITY_WITH_KEY = "No userVehicles exists with the key {";
	private static Log _log = LogFactoryUtil.getLog(userVehiclesPersistenceImpl.class);
}